// Namespaces

// Idee: Namen voneinander entkoppeln, z.B. knnte man zwei Bibliotheken verwenden wollen,
// die beide eine Funktion double sin(double) haben.
// Eigentlich zunchst nicht wichtig -- auer fr den Umgang mit den Standard-Headern.

// Schon Klassen bilden einfache Namensrume:

class TestE
{
    public:

    int f1 (int a)
    {              // Deklaration und Definition der Methode
        return 1*a;
    }
    int f2 (int a); // nur Deklaration, typisch fr Header-Datei
    static int fs (void)
    {
        return 42;
    }

    class meineException  // Exceptions packt man gerne in die Klassen,
    { /*...*/ };           // zu denen sie gehren.

    class InnereKlasse
    {
        public:

        int f3 (int a)
        {               // Deklaration und Definition der Methode
            return 3*a;
        }

        int f4 (int a); // nur Deklaration
        static int fs_innen (void)
        {
            return 43;
        }
    };
};

// Definitionen nachholen (gehren typischerweise in cpp-Datei)

int TestE::f2(int a) // Der Namensraum TestE wird mit :: aufgeschlossen ("scope resolution operator")
// int f2(int a) geht nicht, weil f2 auerhalb vom Namensraum TestE etwas anderes bedeutet (globale Funktion)
{
    if (a == 0)
    {
        throw meineException(); // in diesem Namensraum bekannt
    }

    InnereKlasse b; // in diesem Namensraum bekannt
    b.f3(1); // in diesem Namensraum indirekt bekannt, weil C++ auch im Definitionsraum von b sucht
    // fs_innen(); // in diesem Namensraum unbekannt
    InnereKlasse::fs_innen(); // ok

    return 2*a;
}

int TestE::InnereKlasse::f4(int a) // InnereKlasse ist ein in TestE verschachtelter Namensraum
{
    TestE c; // alle in diesem Namensraum bekannt
    c.f1(1);
    fs();
    fs_innen();

    return 4*a;
}

// eine Funktion, die auerhalb des Namensraums der Klasse TestE lebt:

void test(void)
{
    TestE d; // implizit in den Namensraum
    d.f1(1); // C++ guckt wegen d im TestE-Namensraum nach.
    // fs();   unbekannt
    TestE::fs(); // In Java wrde man TestE.fs(); schreiben.

    // InnereKlasse e;   unbekannt
    TestE::InnereKlasse e;
    TestE::meineException f;
    TestE::InnereKlasse::fs_innen();
}


// Namespaces verallgemeinern diese Art von Kapselung:

namespace TestF
{
    class A
    { /*...*/};

    void g(void) // mit Klasse statt Namespace wre das eine Methode statt einer freien Funktion
    { /*...*/ }
} // kein Semikolon, anders als bei Klasse

int main (int argc, char* (argv[]))
{
    TestF::A a;
    TestF::g();

    // oder den Inhalt des Namensraums importieren:

    using namespace TestF;
    A b;
    g();

    return 0;
}

// WICHTIG!!!
// Die Standardbibliotheken von C und C++ sind mit der ISO-Standardisierung in den
// Namensraum std gewandert. (Gilt noch nicht fr Dev-C++.)

// Wenn man die alten Header einbindet (string.h, math.h ...), ist das egal.

// Wenn man die neuen Header nimmt (string, cmath, alle ohne ".h"),
// muss man jedem Aufruf ein std:: voranstellen oder einfach mit
// using namespace std; den Namenraum ffnen.
// Letzteres mglichst nur in cpp-Dateien, nicht in Headern. Dort std:: nehmen,
// weil Header meist von vielen Dateien eingebunden werden und so eher
// Kollisionen passieren.

// z.B. am Anfang der cpp-Datei:

#include <iostream>
using namespace std;
