#include <string>
#include <iostream>
#include <iomanip>
#include <strstream> // im Standard durch besseren sstream ersetzt, kann Dev-C++ noch nicht, Microsoft Visual C++ schon
using namespace std;

int main ( int argc, char* (argv[]) )
{
    // Strings in C und C++ ******************************************************

    // "zero-terminated" String in C und C++:
    // Man speichert die Zeichen als char-Array und setzt als weiteres Zeichen
    // den Wert 0 dahinter. Die Lnge des Strings ergibt sich nur indirekt!
    char a[] = "Test"; // Array wird automatisch mit fnf Eintrgen angelegt:
                       // vier Zeichen plus die Null
    char b[5];
    b[0] = 'T'; // einfache Anfhrungszeichen: ein Zeichen, kein String
    b[1] = 'e';
    b[2] = 's';
    b[3] = 't';
    b[4] = 0;

    // Die String"klasse" von C++: ******************************************************
    string c("Test");
    string d(a); // aus C-String
    string e(c); // aus string-Objekt
    char ch = e[3]; // auf Zeichen mit [] zugreifen, wie bei Array
    int num = e.length(); // Zahl der Zeichen (ohne Null)
    num = e.size(); // das gleiche
    const char* f = e.c_str(); // in einen C-String umwandeln
                               // Vorsicht: Zeiger kann nach weiterer Operation
                               // auf string-Objekt falsch sein.
    e = c + "Test" + d;
    e += 'x';
    // und dann kann man noch suchen, lschen, ersetzen ...

    // Argumente in string-Objekte packen:
    string* args = new string[argc];
    for (int i = 0; i < argc; i++) // Anmerkung: Bei Microsoft Visual C++ 6.0 ist
    {                              // nun i standardwidrig auch auerhalb von for sichtbar. Kollision.
        args[i]=string(argv[i]);
    }

    // Ein- und Ausgabe mit Streams (nur C++) ******************************************************
    // Fr Stream-Objekte wie cin und cout (Standard-Ein-/Aussgabe) sind
    // die Bit-Verschiebeoperatoren >> und << mit Eingabe und Ausgabe berladen,
    // weil das von der Prioritt passt und hbsch aussieht.
    // stream << irgendwas oder stream >> irgendwas liefert wieder den
    // stream zurck, sodass man Ketten bilden kann.
    // Fr eigene Datentypen kann man << und >> selbst definieren (berladen).

    for (int i = 0; i < argc; i++) // siehe Anmerkung oben
    {
        cout << "Argument Nummer " << i << " ist "<< args[i] << "." << endl;   // "endl" = end line (und Puffer leeren)
    }
    delete[] args;

    int g;
    double h;
    char i[256];
    string j;

    cout << "Geben Sie eine ganze Zahl, eine Gleitkommazahl und zwei Woerter ein!" << endl;
    cin >> g >> h >> i >> j;

    cout << "Es ist angekommen:" << endl << g << endl << h << endl << i << endl << j << endl;

    cout << "Die erste Zahl ist oktal " << oct << g << ", hexadezimal " << hex << g
         << " und dezimal " << dec << g << "." << endl;

    cout << "Die zweite Zahl mit acht Stellen in einem 20 Zeichen breiten Feld:" << endl
         << setprecision(8) << setw(20) << h << endl;
    // Von diesen "Stream-Manipulatoren" gibt es noch viele weitere,
    // obendrein auch Kommandos wie cout.setf(ios_base::showpos); zum Erzwingen des
    // Pluszeichens bei positiven Werten.

    cout << "Tippen Sie mehrere Woerter und betaetigen Sie dann Return!" << endl;

    string k;
    cin.get(); // Im Puffer steht noch ein Return, das muss erst weg.
    getline(cin, k);

    cout << "Es ist angekommen:" << endl << k << endl;

    // Stringstreams ******************************************************
    // Sinn: formatiert aus Strings zu lesen und darein zu schreiben,
    // insbesondere, um Zahlen aus Binrformat in Klartext und zurck zu wandeln.

    char puffer[256];
    ostrstream l(puffer, 256) ; // im Standard durch ostringstream ersetzt, kann Dev-C++ noch nicht, Microsoft Visual C++ schon
    l << "Der Wert ist " << 12.34 << ends; // ends schreibt die abschlieende Null.
    string m = l.str(); // in string-Objekt verwandeln, danach keine weitere Ausgabe mehr erlaubt

    istrstream n("56 78.9"); // im Standard durch istringstream ersetzt, kann Dev-C++ noch nicht
    int p;
    double q;
    n >> p >> q;

    cout << m << "***" << p << "***" << q << endl;

    return 0;
}
