#include <iostream>
#include <fstream>
#include <string>
using namespace std;


// Dateien lesen und schreiben mit Filestreams (nur C++)

int main ( int argc, char* (argv[]) )
{
    cout << "Pfad und Name der zu erzeugenden Datei: ";
    string name;
    cin >> name;

    ofstream geschriebeneDatei(name.c_str(), ios::out | ios::trunc | ios::binary);

    // Bedeutung des Modus:
    // in:        schreiben, out: lesen (geht auch beides zusammen),
    // nocreate:  wenn die Datei noch nicht existiert, sie nicht neu erstellen
    // noreplace: wenn die Datei bereits existiert, sie nicht ffnen
    // app:       bei jede Ausgabeoperation hinten ansetzen (nur mit out)
    // ate:       at end = nach dem ffnen die Position sofort ans Ende setzen
    // trunc:     den alten Inhalt berschreiben (nur mit out)
    // binary:    Binr- statt Textmodus, wirkt sich z.B. auf Zeilenende aus

    if (! geschriebeneDatei)  // Operator ! ist berladen.
    {
        return 42;
    }

    cout << "Was dreimal in der Datei stehen soll: ";
    string inhalt;
    cin.get();
    getline(cin, inhalt);
    cout << endl;

    geschriebeneDatei << inhalt << inhalt << inhalt;
    geschriebeneDatei.close();

    // jetzt lesen

    ifstream geleseneDatei(name.c_str(), ios::in | ios::binary);
    if (! geleseneDatei)  // Operator ! ist berladen.
    {
        return 42;
    }

    cout << "Was in der Datei steht:" << endl << geleseneDatei.rdbuf() << endl;

    // jetzt noch mal einzeln:
    cout << "Nochmal, was in der Datei steht:" << endl;
    geleseneDatei.seekg(0, ios::beg); // spulen, im Ausgabestream heit das seekp

    int ch = geleseneDatei.get();
    while( ! geleseneDatei.eof() )
    {
        cout.put(ch);
        ch = geleseneDatei.get();
    }

    cout << endl;

    // geleseneDatei.close() passiert automatisch beim Destruktoraufruf von geleseneDatei.

    return 0;
}
